
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>读代码整洁之道 / iVAN</title>

    <meta name="description" content="读代码整洁之道       现在的软件系统开发难度主要在于其复杂度和规模,客户需求也不再像Winston Royce瀑布模型期望那样在系统编码前完成所有的设计满足用户软件需求.在这个信息爆炸技术日新月异的时代,需求总是在不停的变化,随之在2001年业界17位大牛聚集在美国犹他州的滑雪胜地雪鸟(Snowbird)雪场,提出了&quot;Agile&quot;(敏捷)软件开发价值观,并在他们的努力推动下,开始在业界流行起来.在&lt;代码整洁之道&gt;(Clean Code),提出一种软件质量,可持续开发不仅在于 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">读代码整洁之道</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>      现在的软件系统开发难度主要在于其复杂度和规模，客户需求也不再像Winston Royce瀑布模型期望那样在系统编码前完成所有的设计满足用户软件需求。在这个信息爆炸技术日新月异的时代，需求总是在不停的变化，随之在2001年业界17位大牛聚集在美国犹他州的滑雪胜地雪鸟（Snowbird）雪场，提出了“Agile”（敏捷）软件开发价值观，并在他们的努力推动下，开始在业界流行起来。在《代码整洁之道》（Clean Code），提出一种软件质量，可持续开发不仅在于项目架构设计，还与代码质量密切相关，代码的整洁度和质量成正比，一份整洁的代码在质量上是可靠的，为团队开发，后期维护，重构奠定了良好的基础。在这本书中作者提出了注重实际开发实践的细节，而不是站在空洞的理论来谈论整洁之道。</p>
<p>什么是整洁代码？不同的人会站在不同的角度阐述不同的说法。而我最喜欢的是Grady Booch（《面向对象分析与设计》作者）阐述：</p>
<p>     “整洁的代码简单直接。整洁的代码如同优美的散文。整洁的代码从不隐藏设计者的意图，充满了干净利落的抽象和直截了当的控制语句。”</p>
<p>       整洁的代码就是一种简约（简单而不过于太简单）的设计，阅读代码的人能很清晰的明白这里在干什么，而不是隐涩难懂，整洁的代码读起来让人感觉到就像阅读散文-艺术的沉淀，作者是精心在意缔造出来。</p>
<p>一：命名</p>
<p>      命名包括变量、函数、参数，类等，一个好的命名能够很好的表述其所承载的业务，从命名上就已经很好的答复了为什么存在，做了什么事，应该怎么用等的大部分的问题，阅读者看到它的时候不必去深究其实现细节，一切都在命名上一目了然。一个好的命名必须是名副其实，不存在歧义（双关语或常见属于冲突），直接了当（否定语句或者误导性命名）。</p>
<p>二：函数：</p>
<p>      从汇编/C时代开始的到现在函数一直都存在与我们开发中不可或缺的一部分，结构化组织，重用.作为函数式语言的一等公民，所有程序的第一组代码。</p>
<ol>
<li>好的函数必须足够的小，其次还是足够的小。很容易想像阅读上千行的代码，是多么巨大的自我心理挑战，在实习的时候工作于毫无分层逻辑的WinForm平台下，完全依赖RAD模式带来后置cs页面上千行的代码，每次修改都令我恼怒，恨不得重写整个业务逻辑。</li>
<li>一个函数在于短小精悍，只作一件事情，并做好这件事，只做一件事才能得到更好的利用函数名表述自己。</li>
<li>好的函数还应该是CQS（查询命令分离）无副作用的（不存在隐藏歧义的背后逻辑），并对其他类型不存在“依恋情节(Feature Envy)“（类中的变量被所有的函数使用这是理想的高内聚，万物皆有其位，而后物尽归其位）。</li>
<li>函数的参数应该足够的少，无最好，一次之，再次为二，尽量避免三个以及三个以上，对于太多的参数你可能该采用IntroduceParameterObject(引入参数对象)。</li>
<li>重复的代码。重复在软件系统是万恶的,我们熟悉的分离关注点，面向对象，设计原则…都是为了减少重复提高重用，Don’t repeat yourself！(DRY)。</li>
</ol>
<p>三：注释、格式：</p>
<p>     并不是写出完备的注释就是好的开发人员，如果代码清晰的表述自己意图，那么注释反而多余。在《重构-改善现有代码之道》中Martin Fowler指出多余的注释是一种代码坏味道。就是好的注释随着项目的维护不断的重构很多时候也会变得不那么适应，而我们很少会去主动维护。再则误导性的注释更为使用者所憎恨。当然有时我们也得使用注释，注释并不是万恶的，当我们没法用代码来描述自己的时候，我们需要注释去描述意图；多余有副作用的代码给使用者提供警告注释。TODO开发时进度控制，比如你在进行较大规模领域重构，目前有些逻辑不再适应，不那么自然，而对它的重构还在任务列表最后，你可以选择标注在TODO中，最后完成从ToDoList中去掉每一个TODO任务。</p>
<p>    良好的代码格式，会使得我们阅读更容易，一套共同的格式会让我们查找理解更快速。每个团队都应该遵循一套固定的代码格式规范，整个软件系统的统风格统一，而不是各自为政各成一体。</p>
<p>四：对象和数据结构：</p>
<p>    数据结构指的就是数据的载体，暴露数据，而几乎没有有意义的行为的贫血类。最常见的应用在分布式服务，以wcf，webservice，reset之类的分布式服务中不可或缺的数据传输对象（DTO）模式，DTO（Request/Response）就是一个很典型的数据载体，只存在简单的get，set属性，并且更倾向于作为值对象存在。而对象则刚好相反作为面向对象的产物，必须封装隐藏数据，而暴露出行为接口，DDD中领域模型倾向于对象不仅在数据更多暴露行为操作自己或者关联状态。</p>
<p>    数据结构和对象之间看是细微的差别却导致了不同的本质区别：使用数据结构的代码便于在不改动现在数据结构的前提下添加新的行为（函数），面向对象代码则便于不改动现 有函数的前提下添加新的类。换句话说就是数据结构难以添加新的的数据类型，因为需要改动所有函数，面向对象的代码则难以添加新的函数，因为需要修改所有的类。在任何一个复杂的系统都会同时存在数据结构和对象，我们需要判断的是我们需要的是需要添加的新的数据类型还是新的行为函数。</p>
<p>   隐藏作为面向对象主要特性中的最重要特性，封装隐藏是面向对象中最重要的特性，一个好的面向对象代码肯定是对对象的内部细节做到很好的隐藏封装，封装过后才有是多态，委派之类的。一个好的面向对象的代码一定是具有很好的隐藏封装，易于测试，不稳定因素往往集中在一处很小或者固定的位置，不稳定因素的变更不会导致更大面积的修改扩散。</p>
<p>  对象的隐藏要求：方法不应和任何调用方法返回的对象操作，换句话之和朋友说话，不和陌生人说话（迪米特法则，或被译为最小知识原则），比如：ctxt.getOptions().getSearchDir().getAbsolutePath()，就是迪米特法则的反例模式。</p>
<p>五：异常处理：</p>
<p>   每个软件系统都避不开异常处理，需要防止它搞乱我们的逻辑。</p>
<ol>
<li>利用异常处理代替返回异常编码，返回异常编码会是的代码中充满了if/else，switch/case扰乱我的代码流转。</li>
<li>对于特定异常扑捉，可以面向异常编程，编写特定的异常类，使得对异常封装转化，更容易捕善后获处理。</li>
<li>避免返回null，在软件系统中最常见头疼的就是NullReferenceException。在非特定场景下，我们应该极力的避免返回null。面对这种场景我们可以采用null object Pattern（空对象模式）返回特例对象，如c#类库中的Guid.Empty，string.Empty；对于集合类型我们可以返回长度0的空集合而非null；</li>
</ol>
<p>六：边界：</p>
<p>   在系统开发中不可能一切都得从零开始，自己写所有的代码，更好的方案是需要整合一些开源或者第三方的项目，为我所用。但是不能让这些非自己的代码渗侵中我们的代码各处，有一些所以功能很强大的第三方产品，但不一定具有很好的抽象。很多时候我更宁愿花些时间抽象出我们自己所需要的接口在第三方类库上外覆一层自己的抽象，这样不仅便于TDD，因为我们能够很好的创建伪对象，使的测试独立不依赖外部资源，得到快速反馈；而且在设计上得到很好的扩展，当由于某些原因如第三方类库不再能满足业务需求，或者权益收费等等，我们可以很好的切换底层而使得修改不会扩散到系统各处。外覆类也是处理遗留代码带入测试容器的一种很好实践。</p>
<p>七:单元测试：</p>
<p>    TDD中测试代码在往往和产品代码差不多，在系统中占据一半的代码量，不好的测试代码也可能拖累项目的开发。整洁的测试代码应该是遵循first原则的：</p>
<ol>
<li>快速（Fast）：测试应该快速，因为需要不断的运行测试得到反馈，我们需要的快速反馈，错误的快速定位。所以你的测试就不能依赖太多的外部资源，数据库，硬件环境等等，对于这些外部资源应该采用伪对象模式来隔离。</li>
<li>独立（Independent）：测试应该是独立的，独立于测试用例之间，独立于特定的环境，独立于测试的运行顺利。数据的独立通常采用两种独立方式，每个测试环境的独立，很多时候我们希望每个测试运行完成后环境（如数据库）和运行前保持一致，如数据库高层次测试我们更希望在每次测试完成后不会带来多余或者改变数据。再则就是数据的隔离，我们的行为测试（BDD，集成高角度的测试）都会依赖一些固定的信息，通常是登陆系统的人员，我们可以采用么个测试建立一个不同的登陆人员来使的每个测试之间的s数据隔离。</li>
<li>可重复（Repeatable）：测试应该可以在任何环境下可重复，可运行，因为测试独立于环境外部资源。</li>
<li>自足验证（Self-Validation）：测试应该有通过失败的标示，从每一个测试上能得到一处代码逻辑的通过失败。每个测试都有对同一件事物的一种行为的断言，也之断言一件事，从而能够很好的错误定位，避免高技巧性的测试。</li>
<li>及时（Timely）：测试应该是及时编写的，TDD要求测试必须在实现代码之前，提前以使用者的角度定义使用接口方式。如果你是在编码后补测试，你的测试覆盖很可能不够，而且容易定式于实现的逻辑写测试，很多时候对于较低层次的测试也不是那么容易写的。一个设计良好的代码必须也是可测试的。</li>
</ol>
<p>八：类：</p>
<p>     面向对象的相似行为的抽象，函数代码块的组织形式，在面向对象中我们的软件系统是由众多的类和类之间的交互协作完成了。面向对象特征：封装，继承，多态度，委派。一个设计良好的类该是具有良好的封装，站在使用者的调度考虑那些是使用接口，那些是内部细节；这是面向对象最主要的特征，但是有时会与测试冲突，可以适当的放开并仅限于于测试调用。继承和多态在面向对象中可以实现重用，但我更倾向于继承不是为了重用，而是隔离变化；大量的滥用继承不干净的继承体系将会导致庞大的继承体系，继承体系中众多职责重复在各个同级派生类，理想的继承应该是满足里氏替换原则（LSP：每个父类出现的地方都应该可以被派生类所替换，并且能正确的工作）；面oo第二原则组合优先。而委派则是一个类把部分功能委派给其他类来完成，体现类之间的协作，类似组合。</p>
<ol>
<li>类第一原则应是是小并足够的小。但与函数不同的是函数以代码行数统计，而类以权责统计。</li>
<li>单一原则（SRP），体现了类只应该做一件事，并且做好它，这样变化修改的理由只有他所做的事。良好的软件设计中系统是由一组大量的短小的类和他们之间功能协作完成的，而不是几个上帝类。</li>
<li>内聚：高内聚低耦合：提出与结构化编程，内聚表述模块内部功能不同操作逻辑之间的距离，如果一个类的每个变量都被每个方法所使用为最大的内聚；耦合描述模块之间的依赖程度；高内聚低耦合以简单的方式表述就是功能完备（高内聚）对象之间是通过稳定的接口（低耦合）交互的。</li>
<li>依赖倒置（DIP）：描述组件之间高层组件不应该依赖于底层组件。依赖倒置是指实现和接口倒置，采用自顶向下的方式关注所需的底层组件接口，而不是其实现。DI模式很好的就是应用IOC（控制反转）框架，构造方式分为分构造注入，函数注入，属性注入；.net平台流行的IOC框架有Unity，Castle windsor，Ninject，Autofac等框架支持，</li>
</ol>
<p>九：并发编程：</p>
<p>     并发是一种时间(When)和目的(What)的解耦,提供应用程序的吞吐量，提高cpu利用率；但是并发编码不是那么容易，再加上临界资源竞争死锁。在并发编程的时候我们必须尽量遵守一些原则：</p>
<ol>
<li>并发已经足够复杂，我们更需要代码分离，分离线程相关代码和非线程相关代码，单一权责，尽可能降低其复杂度。</li>
<li>限制临街资源的作用域，为临界资源加锁是防止并发的策略，但是必须正确的加锁，如果形成等待环，就导致死锁。</li>
<li>利用数据副本（值对象或者克隆）在线程之间传递数据，避免线程之前操作的并发影响；线程独立，使其在自己的环境中运行，不能其他线程共享数据。</li>
<li>对于临界资源加锁应尽量保持加锁范围尽可能的小。</li>
</ol>
<p>   更多关于简单设计，迭进，逐步编程代码，坏味道，并发示例请参见<a href="http://book.51cto.com/art/200912/168058.htm" rel="external nofollow noreferrer">代码整洁之道</a>。</p>
<p>作者：<a href="http://www.cnblogs.com/whitewolf/" rel="external nofollow noreferrer">破  狼</a> <br />
出处：<a href="http://www.cnblogs.com/whitewolf/" rel="external nofollow noreferrer">http://www.cnblogs.com/whitewolf/</a> <br />
本文版权归作者，欢迎转载，但未经作者同意必须保留此段声明，且在文章页面明显位置给出原文连接，否则保留追究法律责任的权利。该文章也同时发布在我的独立博客中-<a href="http://greengerong.com/" rel="external nofollow noreferrer">个人独立博客</a>、<a href="http://www.cnblogs.com/whitewolf/" rel="external nofollow noreferrer">博客园--破狼</a>和<a href="http://whitewolfblog.blog.51cto.com/" rel="external nofollow noreferrer">51CTO--破狼</a>。http://www.cnblogs.com/whitewolf/archive/2012/07/31/2617473.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-24 10:29:47</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>读代码整洁之道的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2y8r4z.html" rel="bookmark">代码整洁之道</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				现在的软件系统开发难度主要在于其复杂度和规模,客户需求也不再像Winston Royce瀑布模型期望那样在系统编码前完成所有的设计满足用户软件需求.在这个信息爆炸技术日新月异的时代,需求总是在不停的变化,随之在2001年业界17位大牛聚集在美国犹他州的滑雪胜地雪鸟(Snowbird)雪场,提出了&quot;Agile&quot;(敏捷)软件开发价值观,并在他们的努力推动下,开始在业界流行起来.在&lt;代码整洁之道&gt;(Clean Code),提出一种软件质量,可持续开发不仅在于项目架构设计,还与代码			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvmmYrb.html" rel="bookmark">《代码整洁之道》目录&mdash;导读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				版权声明 代码整洁之道 Authorized translation from the English language edition, entitled Clean Code: A Handbook of Agile Software Craftsmanship, 9780132350884 by Robert C. Martin, published by Pearson Education, Inc, publishing as Prentice Hall, Copyright 2009			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mq7qB3z.html" rel="bookmark">《代码整洁之道：程序员的职业素养》一一</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 代码整洁之道:程序员的职业素养 1986年1月28日,美国东部时间上午11:39,&quot;挑战者&quot;号航天飞机在发射仅73.124秒后,因右侧固体火箭推进器的故障,在1.5万米的高空化成碎片.7名航天勇士魂断苍穹,其中包括高中教师克丽斯塔·麦考利芙.麦考利芙的母亲亲眼目睹女儿在1.5万米高空中不幸罹难,当时她脸上的表情,至今印刻在我的心头无法拂去. 挑战者号之所以解体,是由于高热气体从出现故障的固体火箭推进器的外壳接缝处泄露出来,喷到外部燃料舱体上.主液氢燃料舱底部发生爆炸,液氢被点燃,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5ReGDz.html" rel="bookmark">《代码整洁之道：程序员的职业素养》导读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 代码整洁之道:程序员的职业素养 1986年1月28日,美国东部时间上午11:39,&quot;挑战者&quot;号航天飞机在发射仅73.124秒后,因右侧固体火箭推进器的故障,在1.5万米的高空化成碎片.7名航天勇士魂断苍穹,其中包括高中教师克丽斯塔·麦考利芙.麦考利芙的母亲亲眼目睹女儿在1.5万米高空中不幸罹难,当时她脸上的表情,至今印刻在我的心头无法拂去. 挑战者号之所以解体,是由于高热气体从出现故障的固体火箭推进器的外壳接缝处泄露出来,喷到外部燃料舱体上.主液氢燃料舱底部发生爆炸,液氢被点燃,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4YrrJb.html" rel="bookmark">《代码整洁之道》&mdash;第13章13&period;1节为什么要并发</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第13章 并发编程代码整洁之道Brett L.Schuchert &quot;对象是过程的抽象.线程是调度的抽象.&quot;--James O Coplien[1] 编写整洁的并发程序很难--非常难.编写在单线程中执行的代码简单得多.编写表面上看来不错.深入进去却支离破碎的多线程代码也简单.系统一旦遭受压力,这种代码就扛不住了. 本章将讨论并发编程的需求及其困难之处,并给出一些对付这些难点.编写整洁的并发代码的建议.最后,我们将讨论与测试并发代码有关的问题. 整洁的并发编程是个复杂话题,值得用一整本书来			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZRjq4z.html" rel="bookmark">《代码整洁之道》&mdash;第1章1&period;1节要有代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第1章 整洁代码代码整洁之道 阅读本书有两种原因:第一,你是个程序员:第二,你想成为更好的程序员.很好.我们需要更好的程序员. 这是本有关编写好程序的书.它充斥着代码.我们要从各个方向来考察这些代码.从顶向下,从底往上,从里而外.读完后,就能知道许多关于代码的事了.而且,我们还能说出好代码和糟糕的代码之间的差异.我们将了解到如何写出好代码.我们也会知道,如何将糟糕的代码改成好代码. 1.1 要有代码有人也许会以为,关于代码的书有点儿落后于时代--代码不再是问题:我们应当关注模型和需求.确实,有人			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjqRonz.html" rel="bookmark">《代码整洁之道：程序员的职业素养》一一第1章 专业主义</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第1章 专业主义 代码整洁之道:程序员的职业素养 &quot;噢,笑吧,科廷,老伙计.这是上帝,或者也可以说是命运或自然,跟我们开的一个玩笑.不过,不管这家伙是谁或是什么,他真幽默!哈哈!&quot; --霍华德,&lt;碧血金沙&gt;这么说,你确实是想成为专业的软件工程师,对吧?你希望能昂首挺胸向世界宣告&quot;我是专业人士&quot;,希望人们满怀尊重地看着你,充满敬意地对待你.希望母亲们会指着你告诉自己的孩子要成为像你这样的人.这些都是你想要的,对吧?			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBGB3oM.html" rel="bookmark">《代码整洁之道》&mdash;第1章1&period;3节混乱的代价</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.3 混乱的代价只要你干过两三年编程,就有可能曾被某人的糟糕的代码绊倒过.如果你编程不止两三年,也有可能被这种代码拖过后腿.进度延缓的程度会很严重.有些团队在项目初期进展迅速,但有那么一两年的时间却慢如蜗行.对代码的每次修改都影响到其他两三处代码.修改无小事.每次添加或修改代码,都得对那堆扭纹柴了然于心,这样才能往上扔更多的扭纹柴.这团乱麻越来越大,再也无法理清,最后束手无策. 随着混乱的增加,团队生产力也持续下降,趋向于零.当生产力下降时,管理层就只有一件事可做了:增加更多人手到项目中,期望			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvG1rVp.html" rel="bookmark">《代码整洁之道：程序员的职业素养》一一1&period;3　首先，不行损害之事</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.3 首先,不行损害之事 那么,我们该如何承担责任呢?的确有一些原则可供参考.援引&quot;希波克拉底誓言&quot;或许显得有点夸张,但没有比这更好的引据了.的确,作为一名有追求有抱负的专业人士,他的首要职责与目标难道不正是尽其所能行有益之事吗? 软件开发人员能做出什么坏事呢?从纯软件角度看,他可以破坏软件的功能与架构.我们会探讨如何避免带来这些破坏. 1.3.1 不要破坏软件功能 显然,我们希望软件可以运行.没错,我们中的大部分人今天之所以是程序员,是因为我们曾开发出可用的软件,而且希望能再度体验			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5N8Wz.html" rel="bookmark" class="title">ubuntu系统中查看硬件信息命令指南</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;    查看ubuntu硬件信息 1, 主板信息 .查看主板 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzV7YQb.html" rel="bookmark" class="title">最新的Javascript和CSS应用技巧荟萃</a>
					<div>
						随着前端技术的发展,javascript和css在网站和web应用中展现出强大的统治力,特别是随着HTML5和CSS3的标准的成熟,我们可以使用javascript和css开发出你想都没有想到过的特效 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zewXjM.html" rel="bookmark" class="title">Asp组件初级入门与精通系列之四</a>
					<div>
						数组问题 数组在程序中使用的很多,而且比较容易出问题 我们通过小例子来看看 打开vb6,新建Activex Dll工程.工程名修改为fCom,类名修改为fC4 点击菜单-&gt;工具-&gt;添加过程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRgg8z.html" rel="bookmark" class="title">COM原理及应用----可连接对象</a>
					<div>
						1.COM的高级特性 COM规范中有一些高级特性,如可连接对象.永久存储.一致的数据传输等,使COM规范具有更强的生命力,它们也是OLE的基础,但它们的应用又不仅仅局限于OLE,这些高级特性已经广泛应 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLrEGb.html" rel="bookmark" class="title">MIDP高级UI的使用（二）List组件</a>
					<div>
						列表List 根据上一节的概述我们已经大概了解了Lcdui 这个包,现在让我们来介绍Screen 类这个类里面的几个重要的类,我们本届家少的是Screen 的一个子类List, 它一共有三种具体的类型 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4d0Op.html" rel="bookmark" class="title">如何安装Oracle 10g RAC For Linux</a>
					<div>
						******************************* 安装操作 author:guoyJoe; createdate:2012-12-13 ************************* ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOyVvM.html" rel="bookmark" class="title">普通用户上网时该注意什么</a>
					<div>
						    和普通人一样,网络犯罪分子也想要过一种轻松.惬意的生活,比如躺着就可以赚大钱,抄&quot;捷径&quot;直抵财富自由--因此,想要阻挠攻击者最好的方法就是给他们的&quot;工作&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKk5WAb.html" rel="bookmark" class="title">网站设计的颜色和反差</a>
					<div>
						  网站设计可以精确地利用LAB,因为它是从图像细微层次细节中进行分色,解决了在RGB和CMYK中都难以解决的许多问题.如果你习惯于在RGB色空间下操作,你可以自由地在LAB和RGB之间转换,在转换中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWEAOb.html" rel="bookmark" class="title">PS优化GIF动态图片的技巧</a>
					<div>
						  最终效果图: 图01 一.修剪动画 首先,你需要在Photoshop中打开视频文件.大多数时候,我们的GIF动态图片并不需要完整序列的动画,因此,我们可以在时间轴面板中修剪视频.打开操作面板,将你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGJw5p.html" rel="bookmark" class="title">Win8&period;1操作系统快捷键驱动的设置方法</a>
					<div>
						  自动更新驱动程序,无非就是在设备管理器中自动更新,或者使用第三方工具,自动更新.前者,有时候不能自动胜任,总是没有合适的驱动程序.后者,有时候也不能装上匹配的驱动程序,还会将不需要的程序装在计算机 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg30qmM.html" rel="bookmark" class="title">windows8系统轻松锁屏技巧</a>
					<div>
						  windows8系统轻松锁屏技巧:安装了win8系统的用户都会知道,每次启动Win8的登录界面屏幕便会被一副背景的图片锁住,不熟悉Win8系统的用户可能会傻傻地在干等,其实Win8可以像我们的手机 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBK3NNM.html" rel="bookmark" class="title">IE11浏览器更多新功能曝光</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   随着版本号为9364的Windows Blue系统正式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQKG5p.html" rel="bookmark" class="title">【转】右键菜单大揭密</a>
					<div>
						在Windows系统中,只要对着桌面或是文件(夹)单击右键,就会弹出一个快捷菜单,里面有对该文件(夹)的一些常用×作命令,通过右键菜单,可以方便用户对文件的某些×作.不知道你是否对它感兴趣?是否想对它 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDW9L6p.html" rel="bookmark" class="title">精　挑　细　选</a>
					<div>
						精 挑 细 选 时间限制:3000 ms  |  内存限制:65535 KB 难度:1 描述 小王是公司的仓库管理员,一天,他接到了这样一个任务:从仓库中找出一根钢管.这听起来不算什么,但是这根钢管的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEoG2M.html" rel="bookmark" class="title">MongoDB权限管理代码分析</a>
					<div>
						本文主要介绍Mongodb RBAC(role based access control)权限管理机制,其核心是给每个用户赋予一定的权限,用户连接mongodb前需先验证,验证通过后即拥有用户的权限, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAB87p.html" rel="bookmark" class="title">代理魔兽网易的转型还是研发的失败</a>
					<div>
						记得曾经看过这样一句话&quot;叶子的离去,是风的追求还是书的不挽留&quot;.自从网易公司宣布代理&lt;魔兽世界&gt;以来风波不断,不仅关于&lt;魔兽世界&gt;游戏本身讨论不绝于耳,更是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xRk3b.html" rel="bookmark" class="title">C&plus;&plus;第17周项目2&mdash;&mdash;用指针玩字符串（5）去前导空格</a>
					<div>
						课程首页地址:http://blog.csdn.net/sxhelijian/article/details/7910565 [项目2-用指针玩字符串]神奇的指针哟,指向整型的指针int *p1,可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAEv7XM.html" rel="bookmark" class="title">移动互联网下的服务转型&horbar;&horbar;10086APP成长的探索</a>
					<div>
						APP是移动互联网下连接用户需求和企业发展的桥梁.10086APP是移动公司移动互联网转型的自有渠道,具有高效低成本特点,与公司战略发展契合,有较大战略发展意义.广东移动10086APP经过两年提升, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwGOZM.html" rel="bookmark" class="title">如何成为软件架构师？</a>
					<div>
						问题描述 如何成为软件架构师? 如何成为软件架构师?软件架构师与系统架构师的区别?成为软件架构师,需要具备哪些技术.能力与经验.还有就是,学习路线!					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mgw1omM.html" rel="bookmark" class="title">360手机助手只有TOP10，其他4个应用市场都是TOP20</a>
					<div>
						本文选择360手机助手.百度.豌豆荚.91助手和应用宝5个应用市场,分别收集整理各市场&quot;排行榜&quot;,在此基础上,观察.归纳累计下载总量排名前20的客户端,并总结其下载量等级.分类.特 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwJ6Qdp.html" rel="bookmark" class="title">Twitter推出德语版加速国际化扩张</a>
					<div>
						北京时间12月17日上午消息,据国外媒体报道,Twitter周三推出了德语版本,进一步加速国际化扩张. 最近几周,Twitter先后推出了西班牙语.法语和意大利语版本.Twitter本次使用德语发布了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXK2RWM.html" rel="bookmark" class="title">java多线程返回值使用示例&lpar;callable与futuretask&rpar;&lowbar;java</a>
					<div>
						Callable接口类似于Runnable,从名字就可以看出来了,但是Runnable不会返回结果,并且无法抛出返回结果的异常,而Callable功能更强大一些,被线程执行后,可以返回值,这个返回值可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jqL4p.html" rel="bookmark" class="title">部署PHP时的4个配置修改说明&lowbar;php技巧</a>
					<div>
						以下就是部署PHP时的4个配置修改说明,大家一个一个进行学习研究. 1.short_open_tag 是什么呢?决定是否允许使用代码开始标志的缩写形式(&lt;? ?&gt; ). 如果要和 XML  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwK9qRz.html" rel="bookmark" class="title">JAVA中 Spring定时器的两种实现方式&lowbar;java</a>
					<div>
						目前有两种流行Spring定时器配置:Java的Timer类和OpenSymphony的Quartz. 1.Java Timer定时 首先继承java.util.TimerTask类实现run方法 i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mlmlnap.html" rel="bookmark" class="title">css li应用基础实例教程</a>
					<div>
						 代码如下 复制代码 &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http:// ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxE8A0p.html" rel="bookmark" class="title">工作室怎么赚钱？工作室赚钱思考</a>
					<div>
						给大家推荐一个比较简单的挣钱方法:http://www.111cn.net/cp/ad_count.php?ad_id=446 想游戏赚钱,找一款自己熟悉的游戏,手动进去玩个十天半个月的,把最新的活动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7QV8XM.html" rel="bookmark" class="title">java 條件運算符替代不了if else語句</a>
					<div>
						问题描述 java 條件運算符替代不了if else語句 使用if else語句可行,條件運算符則展示&quot;類型不匹配&quot; 求解 .. 解决方案 ?:是表达式, 你可以写 String  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEY3lPb.html" rel="bookmark" class="title">关于freemaker中&quest;和&excl;的语法问题</a>
					<div>
						问题描述 关于freemaker中?和!的语法问题 我想检查实体某个属性,实体是A,属性是b 要检查的内容包括:是否为空:里面有没有特定字符串,有的话替换为abc 语句这样: A.b!&quot;&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1DL6Kb.html" rel="bookmark" class="title">web2&period;0下的编辑理念变革</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 &quot;内容为王&quot;被我们用了很多年.其实,电视的内容和报纸是很不一样的,互联网的内容和电视.报纸的内容更不是一个概念.进入电子媒体时代,从 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myv3Qvp.html" rel="bookmark" class="title">惠普华美旗舰体验中心在中国丹东盛大启航</a>
					<div>
						2011年7月3日,惠普华美旗舰体验中心在中国最美的边境城市丹东盛大启航.这是东北首家包含惠普全线新品和全面解决方案的旗舰级体验中心,代表着惠普服务创新的最前沿尝试,是惠普对辽宁长期投入的又一里程碑, ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
